import { SvelteElement, init, attribute_to_object, safe_not_equal, insert, flush, element, noop, detach, destroy_each, text, space, attr, append, set_data } from "svelte/internal";
import { onMount } from "svelte";
function get_each_context(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[9] = list[i];
  return child_ctx;
}
function get_each_context_1(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[12] = list[i];
  return child_ctx;
}
function create_each_block_1(ctx) {
  let span;
  let t_value = ctx[12] + "";
  let t;
  return {
    c() {
      span = element("span");
      t = text(t_value);
      attr(span, "class", "tag");
    },
    m(target, anchor) {
      insert(target, span, anchor);
      append(span, t);
    },
    p(ctx2, dirty) {
      if (dirty & 1 && t_value !== (t_value = ctx2[12] + ""))
        set_data(t, t_value);
    },
    d(detaching) {
      if (detaching)
        detach(span);
    }
  };
}
function create_each_block(ctx) {
  let li;
  let a;
  let div;
  let span;
  let t0_value = ctx[1].format(ctx[9].date) + "";
  let t0;
  let t1;
  let t2;
  let h3;
  let t3_value = ctx[9].title + "";
  let t3;
  let t4;
  let p;
  let t5_value = ctx[9].description + "";
  let t5;
  let a_href_value;
  let t6;
  let li_class_value;
  let each_value_1 = ctx[9].tag.split(" ");
  let each_blocks = [];
  for (let i = 0; i < each_value_1.length; i += 1) {
    each_blocks[i] = create_each_block_1(get_each_context_1(ctx, each_value_1, i));
  }
  return {
    c() {
      li = element("li");
      a = element("a");
      div = element("div");
      span = element("span");
      t0 = text(t0_value);
      t1 = space();
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      t2 = space();
      h3 = element("h3");
      t3 = text(t3_value);
      t4 = space();
      p = element("p");
      t5 = text(t5_value);
      t6 = space();
      attr(span, "class", "pubdate");
      attr(div, "class", "date-tags");
      attr(a, "href", a_href_value = ctx[9].href);
      attr(li, "class", li_class_value = ctx[9].tag);
    },
    m(target, anchor) {
      insert(target, li, anchor);
      append(li, a);
      append(a, div);
      append(div, span);
      append(span, t0);
      append(div, t1);
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].m(div, null);
      }
      append(a, t2);
      append(a, h3);
      append(h3, t3);
      append(a, t4);
      append(a, p);
      append(p, t5);
      append(li, t6);
    },
    p(ctx2, dirty) {
      if (dirty & 1 && t0_value !== (t0_value = ctx2[1].format(ctx2[9].date) + ""))
        set_data(t0, t0_value);
      if (dirty & 1) {
        each_value_1 = ctx2[9].tag.split(" ");
        let i;
        for (i = 0; i < each_value_1.length; i += 1) {
          const child_ctx = get_each_context_1(ctx2, each_value_1, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
          } else {
            each_blocks[i] = create_each_block_1(child_ctx);
            each_blocks[i].c();
            each_blocks[i].m(div, null);
          }
        }
        for (; i < each_blocks.length; i += 1) {
          each_blocks[i].d(1);
        }
        each_blocks.length = each_value_1.length;
      }
      if (dirty & 1 && t3_value !== (t3_value = ctx2[9].title + ""))
        set_data(t3, t3_value);
      if (dirty & 1 && t5_value !== (t5_value = ctx2[9].description + ""))
        set_data(t5, t5_value);
      if (dirty & 1 && a_href_value !== (a_href_value = ctx2[9].href)) {
        attr(a, "href", a_href_value);
      }
      if (dirty & 1 && li_class_value !== (li_class_value = ctx2[9].tag)) {
        attr(li, "class", li_class_value);
      }
    },
    d(detaching) {
      if (detaching)
        detach(li);
      destroy_each(each_blocks, detaching);
    }
  };
}
function create_fragment(ctx) {
  let ul;
  let each_value = ctx[0];
  let each_blocks = [];
  for (let i = 0; i < each_value.length; i += 1) {
    each_blocks[i] = create_each_block(get_each_context(ctx, each_value, i));
  }
  return {
    c() {
      ul = element("ul");
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      this.c = noop;
    },
    m(target, anchor) {
      insert(target, ul, anchor);
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].m(ul, null);
      }
    },
    p(ctx2, [dirty]) {
      if (dirty & 3) {
        each_value = ctx2[0];
        let i;
        for (i = 0; i < each_value.length; i += 1) {
          const child_ctx = get_each_context(ctx2, each_value, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
          } else {
            each_blocks[i] = create_each_block(child_ctx);
            each_blocks[i].c();
            each_blocks[i].m(ul, null);
          }
        }
        for (; i < each_blocks.length; i += 1) {
          each_blocks[i].d(1);
        }
        each_blocks.length = each_value.length;
      }
    },
    i: noop,
    o: noop,
    d(detaching) {
      if (detaching)
        detach(ul);
      destroy_each(each_blocks, detaching);
    }
  };
}
const cors = "https://proxy-j4bychtceq-uc.a.run.app/";
let CACHE_ARTICLES = "rssfeedcache";
let CACHE_LAST = "rssfeedlastfetch";
function getContent(xmlObj, tagName) {
  return xmlObj.getElementsByTagName(tagName)[0].textContent;
}
function instance($$self, $$props, $$invalidate) {
  let { feeds } = $$props;
  let { dedupe = true } = $$props;
  let { cache = true } = $$props;
  let { cachetimeout = 3 * 60 * 1e3 } = $$props;
  let parsedFeeds = [];
  try {
    parsedFeeds = JSON.parse(feeds);
  } catch (err) {
    console.warn(`Feeds isn't JSON, will try single URL: ${feeds}`, err.message);
  }
  if (!parsedFeeds.length) {
    try {
      const checkURL = new URL(feeds);
      if (checkURL.host && /^https?:/.test(checkURL.protocol))
        parsedFeeds.push(feeds);
      else
        console.warn(`Feed URL: "${feeds}" is malformed, it must be a full URL that starts with https:// or http:// and is otherwise properly shaped`);
    } catch (err) {
      console.warn(`Feed: "${feeds}" is malformed, see docs`, err.message);
    }
  }
  let articles = [];
  let lastFetch = localStorage.getItem(CACHE_LAST) || 0;
  onMount(async () => {
    const timeDelta = Date.now() - lastFetch;
    if (cache && timeDelta < cachetimeout * 2) {
      $$invalidate(0, articles = JSON.parse(localStorage.getItem(CACHE_ARTICLES)));
      console.log(`${articles.length} articles from ${parseInt(timeDelta / (60 * 1e3))}m old cache`);
      $$invalidate(0, articles = articles.map((a) => {
        a.date = new Date(a.date);
        return a;
      }));
      if (timeDelta < cachetimeout) {
        console.log("cached articles are fresh");
        return;
      } else {
        console.log("fetching fresh articles");
      }
    }
    await Promise.all(parsedFeeds.map(async (f) => {
      const response = await fetch(`${cors}${f.src}`);
      const text2 = await response.text();
      const data = new window.DOMParser().parseFromString(text2, "text/xml");
      let channel = data.getElementsByTagName("channel");
      let items = Array.prototype.slice.call(channel[0].children);
      items.forEach((item) => {
        if (item.tagName === "item") {
          const titleEl = document.createElement("h3");
          titleEl.innerHTML = getContent(item, "title");
          const titleText = titleEl.innerText;
          const descEl = document.createElement("div");
          descEl.innerHTML = getContent(item, "description");
          const extant = articles.some((a) => a.title === titleText);
          if (dedupe && extant) {
            $$invalidate(0, articles = articles.map((c) => {
              if (c.title === titleText && !c.tag.includes(f.tag))
                c.tag += " " + f.tag;
              return c;
            }));
            return;
          }
          articles.push({
            "feed": f.title,
            "title": titleEl.innerText,
            "description": descEl.innerText,
            "href": getContent(item, "link"),
            "date": new Date(getContent(item, "pubDate")),
            "tag": f.tag
          });
        }
      });
    }));
    $$invalidate(0, articles = articles.sort((a, b) => b.date - a.date));
    localStorage.setItem(CACHE_ARTICLES, JSON.stringify(articles));
    localStorage.setItem(CACHE_LAST, Date.now());
  });
  const dtFormat = new Intl.DateTimeFormat("en", { dateStyle: "medium" });
  $$self.$$set = ($$props2) => {
    if ("feeds" in $$props2)
      $$invalidate(2, feeds = $$props2.feeds);
    if ("dedupe" in $$props2)
      $$invalidate(3, dedupe = $$props2.dedupe);
    if ("cache" in $$props2)
      $$invalidate(4, cache = $$props2.cache);
    if ("cachetimeout" in $$props2)
      $$invalidate(5, cachetimeout = $$props2.cachetimeout);
  };
  $$self.$$.update = () => {
    if ($$self.$$.dirty & 1) {
      articles.length;
    }
  };
  return [articles, dtFormat, feeds, dedupe, cache, cachetimeout];
}
class Src extends SvelteElement {
  constructor(options) {
    super();
    this.shadowRoot.innerHTML = `<style>a{display:block;text-decoration:none;padding:0.5em}h3,p{margin:0.4em 0 0.3em}a:hover h3{text-decoration:underline}ul{list-style-type:none;padding:0}.date-tags{margin-top:0.75em}.tag,.pubdate{font-size:0.8em}.tag{margin:0 0.25em;padding:0.2em 0.4em;border-radius:0.2rem;background-color:#CCC7;text-transform:uppercase}</style>`;
    init(this, {
      target: this.shadowRoot,
      props: attribute_to_object(this.attributes),
      customElement: true
    }, instance, create_fragment, safe_not_equal, {
      feeds: 2,
      dedupe: 3,
      cache: 4,
      cachetimeout: 5
    }, null);
    if (options) {
      if (options.target) {
        insert(options.target, this, options.anchor);
      }
      if (options.props) {
        this.$set(options.props);
        flush();
      }
    }
  }
  static get observedAttributes() {
    return ["feeds", "dedupe", "cache", "cachetimeout"];
  }
  get feeds() {
    return this.$$.ctx[2];
  }
  set feeds(feeds) {
    this.$$set({ feeds });
    flush();
  }
  get dedupe() {
    return this.$$.ctx[3];
  }
  set dedupe(dedupe) {
    this.$$set({ dedupe });
    flush();
  }
  get cache() {
    return this.$$.ctx[4];
  }
  set cache(cache) {
    this.$$set({ cache });
    flush();
  }
  get cachetimeout() {
    return this.$$.ctx[5];
  }
  set cachetimeout(cachetimeout) {
    this.$$set({ cachetimeout });
    flush();
  }
}
customElements.define("taocode-rss-display", Src);
export { Src as default };
